#include "arduinoFFT.h"
#include <Servo.h>
#include <Stepper.h>
 
#define SAMPLES 256             //Binanzahl, muss eine Zweierpotenz sein
#define SAMPLING_FREQUENCY 6000 //Hz, muss weniger als 10k sein. Die Definition gibt das doppelte des beachteten Frequenzbereichs vor.
#define MICA A0                 //Pin für Mikro
 
arduinoFFT FFT = arduinoFFT();
unsigned int sampling_period_us;
unsigned long microseconds;
double vReal[SAMPLES];
double vImag[SAMPLES];
double val[SAMPLES];
unsigned long sum = 0;
unsigned long sumC = 0;
double avg[SAMPLES] = {0};
 
//Bauteile definieren//Feld0 steht für den PIN, Feld1 steht für den Case
byte led1[2] = {10, 0};
byte led2[2] = { 9, 0};

Servo servoLS;
int servoL[2] = { 0, 0};
Servo servoRS;
int servoR[2] = { 1, 0};

int STEPS = 400;
Stepper stepperBasis(STEPS, 11, 12);
//--------------------------------------------------------------------
void setup() {
  Serial.begin(115200);
  sampling_period_us = round(1000000*(1.0/SAMPLING_FREQUENCY));
  
  servoLS.attach(servoL[0]); //linke Schulter
  servoRS.attach(servoR[0]); //rechte Schulter
    
  pinMode(led1[0], OUTPUT);
  pinMode(led2[0], OUTPUT);
  
  stepperBasis.setSpeed(800);
}
//--------------------------------------------------------------------
void loop() {
 //SAMPLING
 for(int i=0; i<SAMPLES; i++) {
      microseconds = micros(); //Läuft nach 70 Minuten über!
      vReal[i] = analogRead(MICA);
      vImag[i] = 0;
      while(micros() < (microseconds + sampling_period_us)){
      }
  }

  //Fast Fourier Transformation
  //FFT.Windowing(vReal, SAMPLES, FFT_WIN_TYP_HAMMING, FFT_FORWARD);
  FFT.Compute(vReal, vImag, SAMPLES, FFT_FORWARD);
  //FFT.ComplexToMagnitude(vReal, vImag, SAMPLES);
  //double peak = FFT.MajorPeak(vReal, SAMPLES, SAMPLING_FREQUENCY);
  for(int i = 0; i<2; i++) {
    vReal[i] = 0;
    vImag[i] = 0;
  }

  //Printing/Analyse
  for(int i=0; i<(SAMPLES/2); i++) {
    float p = sqrt(vReal[i]*vReal[i]+vImag[i]*vImag[i]);
    val[i] = p;
    Serial.println(val[i]); //Gibt die Bins auf dem seriellen Plotter aus
  }
    
  //Körperteile ansteuern
  for(int i=0; i<SAMPLES/2; i++) {
    boolean hear = val[i]>600;    //wie laut muss der Bin sein, um zu reagieren?
    if(i<SAMPLES/2*1/3 && hear) {
      switch(led1[1]) {
        case 0: 
          digitalWrite(led1[0], HIGH);
          led1[1] = 1;
          break;
        case 1:
          digitalWrite(led1[0], LOW);
          led1[1] = 0;
          break;
       }
    }
    if(i>SAMPLES/2*1/3 && i<SAMPLES/2*2/3 && hear) {
      switch(led2[1]) {
        case 0: 
          digitalWrite(led2[0], HIGH);
          led2[1] = 1;
          break;
        case 1:
          digitalWrite(led2[0], LOW);
          led2[1] = 0;
          break;
       }
    }
    if(i<SAMPLES/2*2/5 && hear) {
      switch(servoL[1]) {
        case 0: 
          servoLS.write(70);
          servoL[1] = 1;
          break;
        case 1:
          servoLS.write(90);
          servoL[1] = 0;
          break;
       }
      //stepperBasis.step(50); //Stepper sich in eine Richtung bewegen
    }
    if(i>SAMPLES/2*2/5 && hear) {
      switch(servoR[1]) {
        case 0: 
          servoRS.write(80);
          servoR[1] = 1;
          break;
        case 1:
          servoRS.write(100);
          servoR[1] = 0;
          break;
       }
      //stepperBasis.step(-10); //Stepper sich in die andere Richtung bewegen.
    }
    sum+=val[i];
  }
  if(sum > sumC*1.2) stepperBasis.step(500); //wenn das alte Array sich stark vom neuen unterscheidet, dann drehe dich
  sumC = sum;
  sum = 0;
    
  delay(50);  //Repeat the process every second
}

/*--------------------------------------------------------------------
//Frequenzen den Bins zuordnen
double width = (SAMPLING_FREQUENCY/2)/SAMPLES;
double freq[SAMPLES];

  //Vergleichsarray machen für Frequenzen
  for(int i=0; i<SAMPLES; i++) {
    freq[i] = (i+1)*SAMPLING_FREQUENCY/SAMPLES;
  }
}
//Durchschnitt zwischen vorherigem und derzeitigem Array erzeugen
if(avg[0] = 0) {
  for(int i=0; i<(SAMPLES/2); i++) {
    avg[i] = val[i];
  }
}
for(int i=0; i<(SAMPLES/2); i++) {
  avg[i] = (avg[i]+val[i])/2;
}
*/
